#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_EXT_VALIDATION_CACHE_SPEC_VERSION")]
pub const EXT_VALIDATION_CACHE_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_EXT_VALIDATION_CACHE_EXTENSION_NAME")]
pub const EXT_VALIDATION_CACHE_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_EXT_validation_cache");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_CREATE_VALIDATION_CACHE_EXT: *const std::os::raw::c_char = crate::cstr!("vkCreateValidationCacheEXT");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_DESTROY_VALIDATION_CACHE_EXT: *const std::os::raw::c_char = crate::cstr!("vkDestroyValidationCacheEXT");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_VALIDATION_CACHE_DATA_EXT: *const std::os::raw::c_char = crate::cstr!("vkGetValidationCacheDataEXT");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_MERGE_VALIDATION_CACHES_EXT: *const std::os::raw::c_char = crate::cstr!("vkMergeValidationCachesEXT");
crate::non_dispatchable_handle!(ValidationCacheEXT, VALIDATION_CACHE_EXT, "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkValidationCacheEXT.html)) · Non-dispatchable Handle <br/> VkValidationCacheEXT - Opaque handle to a validation cache object\n[](#_c_specification)C Specification\n----------\n\nValidation cache objects allow the result of internal validation to be\nreused, both within a single application run and between multiple runs.\nReuse within a single run is achieved by passing the same validation cache\nobject when creating supported Vulkan objects.\nReuse across runs of an application is achieved by retrieving validation\ncache contents in one run of an application, saving the contents, and using\nthem to preinitialize a validation cache on a subsequent run.\nThe contents of the validation cache objects are managed by the validation\nlayers.\nApplications **can** manage the host memory consumed by a validation cache\nobject and control the amount of data retrieved from a validation cache\nobject.\n\nValidation cache objects are represented by [`crate::vk::ValidationCacheEXT`]handles:\n\n```\n// Provided by VK_EXT_validation_cache\nVK_DEFINE_NON_DISPATCHABLE_HANDLE(VkValidationCacheEXT)\n```\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ShaderModuleValidationCacheCreateInfoEXT`], [`crate::vk::DeviceLoader::create_validation_cache_ext`], [`crate::vk::DeviceLoader::destroy_validation_cache_ext`], [`crate::vk::DeviceLoader::get_validation_cache_data_ext`], [`crate::vk::DeviceLoader::merge_validation_caches_ext`]\n[](#_document_notes)Document Notes\n----------\n\nFor more information, see the [Vulkan Specification](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#VkValidationCacheEXT)\n\nThis page is extracted from the Vulkan Specification.\nFixes and changes should be made to the Specification, not directly.\n[](#_copyright)Copyright\n----------\n\nCopyright 2014-2021 The Khronos Group Inc.\n\nSPDX-License-Identifier: CC-BY-4.0\n", "VkValidationCacheEXT");
bitflags::bitflags! { # [doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkValidationCacheCreateFlagsEXT.html)) · Bitmask of [`ValidationCacheCreateFlagBitsEXT`] <br/> VkValidationCacheCreateFlagsEXT - Reserved for future use\n[](#_c_specification)C Specification\n----------\n\n```\n// Provided by VK_EXT_validation_cache\ntypedef VkFlags VkValidationCacheCreateFlagsEXT;\n```\n[](#_description)Description\n----------\n\n[`crate::vk::ValidationCacheCreateFlagBitsEXT`] is a bitmask type for setting a mask,\nbut is currently reserved for future use.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::ValidationCacheCreateInfoEXT`]\n"] # [doc (alias = "VkValidationCacheCreateFlagsEXT")] # [derive (Default)] # [repr (transparent)] pub struct ValidationCacheCreateFlagsEXT : u32 { # [cfg (empty_bitflag_workaround)] const EMPTY_BITFLAG_WORKAROUND = 0 ; } }
#[doc = "<s>Vulkan Manual Page</s> · Bits enum of [`ValidationCacheCreateFlagsEXT`] <br/> "]
#[doc(alias = "VkValidationCacheCreateFlagBitsEXT")]
#[derive(Copy, Clone, PartialEq, Eq, Hash, Default, Ord, PartialOrd)]
#[repr(transparent)]
pub struct ValidationCacheCreateFlagBitsEXT(pub u32);
impl ValidationCacheCreateFlagBitsEXT {
    #[inline]
    #[doc = "Converts this enum variant to the corresponding bitmask"]
    pub const fn bitmask(&self) -> ValidationCacheCreateFlagsEXT {
        ValidationCacheCreateFlagsEXT::from_bits_truncate(self.0)
    }
}
impl std::fmt::Debug for ValidationCacheCreateFlagBitsEXT {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.write_str(match self {
            _ => "(unknown variant)",
        })
    }
}
#[doc = "Provided by [`crate::extensions::ext_validation_cache`]"]
impl crate::vk1_0::StructureType {
    pub const VALIDATION_CACHE_CREATE_INFO_EXT: Self = Self(1000160000);
    pub const SHADER_MODULE_VALIDATION_CACHE_CREATE_INFO_EXT: Self = Self(1000160001);
}
#[doc = "Provided by [`crate::extensions::ext_validation_cache`]"]
impl crate::vk1_0::ObjectType {
    pub const VALIDATION_CACHE_EXT: Self = Self(1000160000);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkValidationCacheHeaderVersionEXT.html)) · Enum <br/> VkValidationCacheHeaderVersionEXT - Encode validation cache version\n[](#_c_specification)C Specification\n----------\n\nPossible values of the second group of four bytes in the header returned by[`crate::vk::DeviceLoader::get_validation_cache_data_ext`], encoding the validation cache version,\nare:\n\n```\n// Provided by VK_EXT_validation_cache\ntypedef enum VkValidationCacheHeaderVersionEXT {\n    VK_VALIDATION_CACHE_HEADER_VERSION_ONE_EXT = 1,\n} VkValidationCacheHeaderVersionEXT;\n```\n[](#_description)Description\n----------\n\n* [`Self::ONE_EXT`] specifies version one\n  of the validation cache.\n[](#_see_also)See Also\n----------\n\n[`crate::vk::DeviceLoader::create_validation_cache_ext`], [`crate::vk::DeviceLoader::get_validation_cache_data_ext`]\n"]
#[doc(alias = "VkValidationCacheHeaderVersionEXT")]
#[derive(Copy, Clone, PartialEq, Eq, Hash, Default, Ord, PartialOrd)]
#[repr(transparent)]
pub struct ValidationCacheHeaderVersionEXT(pub i32);
impl std::fmt::Debug for ValidationCacheHeaderVersionEXT {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.write_str(match self {
            &Self::ONE_EXT => "ONE_EXT",
            _ => "(unknown variant)",
        })
    }
}
#[doc = "Provided by [`crate::extensions::ext_validation_cache`]"]
impl crate::extensions::ext_validation_cache::ValidationCacheHeaderVersionEXT {
    pub const ONE_EXT: Self = Self(1);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCreateValidationCacheEXT.html)) · Function <br/> vkCreateValidationCacheEXT - Creates a new validation cache\n[](#_c_specification)C Specification\n----------\n\nTo create validation cache objects, call:\n\n```\n// Provided by VK_EXT_validation_cache\nVkResult vkCreateValidationCacheEXT(\n    VkDevice                                    device,\n    const VkValidationCacheCreateInfoEXT*       pCreateInfo,\n    const VkAllocationCallbacks*                pAllocator,\n    VkValidationCacheEXT*                       pValidationCache);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that creates the validation cache\n  object.\n\n* [`Self::p_create_info`] is a pointer to a [`crate::vk::ValidationCacheCreateInfoEXT`]structure containing the initial parameters for the validation cache\n  object.\n\n* [`Self::p_allocator`] controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n\n* [`Self::p_validation_cache`] is a pointer to a [`crate::vk::ValidationCacheEXT`]handle in which the resulting validation cache object is returned.\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>Applications **can** track and manage the total host memory size of a<br/>validation cache object using the [`Self::p_allocator`].<br/>Applications **can** limit the amount of data retrieved from a validation cache<br/>object in [`crate::vk::DeviceLoader::get_validation_cache_data_ext`].<br/>Implementations **should** not internally limit the total number of entries<br/>added to a validation cache object or the total host memory consumed.|\n|---|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nOnce created, a validation cache **can** be passed to the[`crate::vk::PFN_vkCreateShaderModule`] command by adding this object to the[`crate::vk::ShaderModuleCreateInfo`] structure’s `pNext` chain.\nIf a [`crate::vk::ShaderModuleValidationCacheCreateInfoEXT`] object is included in\nthe [`crate::vk::ShaderModuleCreateInfo::p_next`] chain, and its`validationCache` field is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), the implementation\nwill query it for possible reuse opportunities and update it with new\ncontent.\nThe use of the validation cache object in these commands is internally\nsynchronized, and the same validation cache object **can** be used in multiple\nthreads simultaneously.\n\n|   |Note<br/><br/>Implementations **should** make every effort to limit any critical sections to<br/>the actual accesses to the cache, which is expected to be significantly<br/>shorter than the duration of the [`crate::vk::PFN_vkCreateShaderModule`] command.|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-vkCreateValidationCacheEXT-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkCreateValidationCacheEXT-pCreateInfo-parameter  \n  [`Self::p_create_info`] **must** be a valid pointer to a valid [`crate::vk::ValidationCacheCreateInfoEXT`] structure\n\n* []() VUID-vkCreateValidationCacheEXT-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkCreateValidationCacheEXT-pValidationCache-parameter  \n  [`Self::p_validation_cache`] **must** be a valid pointer to a [`crate::vk::ValidationCacheEXT`] handle\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::Device`], [`crate::vk::ValidationCacheCreateInfoEXT`], [`crate::vk::ValidationCacheEXT`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkCreateValidationCacheEXT = unsafe extern "system" fn(device: crate::vk1_0::Device, p_create_info: *const crate::extensions::ext_validation_cache::ValidationCacheCreateInfoEXT, p_allocator: *const crate::vk1_0::AllocationCallbacks, p_validation_cache: *mut crate::extensions::ext_validation_cache::ValidationCacheEXT) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDestroyValidationCacheEXT.html)) · Function <br/> vkDestroyValidationCacheEXT - Destroy a validation cache object\n[](#_c_specification)C Specification\n----------\n\nTo destroy a validation cache, call:\n\n```\n// Provided by VK_EXT_validation_cache\nvoid vkDestroyValidationCacheEXT(\n    VkDevice                                    device,\n    VkValidationCacheEXT                        validationCache,\n    const VkAllocationCallbacks*                pAllocator);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that destroys the validation cache\n  object.\n\n* [`Self::validation_cache`] is the handle of the validation cache to destroy.\n\n* [`Self::p_allocator`] controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkDestroyValidationCacheEXT-validationCache-01537  \n   If [`crate::vk::AllocationCallbacks`] were provided when [`Self::validation_cache`]was created, a compatible set of callbacks **must** be provided here\n\n* []() VUID-vkDestroyValidationCacheEXT-validationCache-01538  \n   If no [`crate::vk::AllocationCallbacks`] were provided when[`Self::validation_cache`] was created, [`Self::p_allocator`] **must** be `NULL`\n\nValid Usage (Implicit)\n\n* []() VUID-vkDestroyValidationCacheEXT-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkDestroyValidationCacheEXT-validationCache-parameter  \n   If [`Self::validation_cache`] is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), [`Self::validation_cache`] **must** be a valid [`crate::vk::ValidationCacheEXT`] handle\n\n* []() VUID-vkDestroyValidationCacheEXT-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkDestroyValidationCacheEXT-validationCache-parent  \n   If [`Self::validation_cache`] is a valid handle, it **must** have been created, allocated, or retrieved from [`Self::device`]\n\nHost Synchronization\n\n* Host access to [`Self::validation_cache`] **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::Device`], [`crate::vk::ValidationCacheEXT`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkDestroyValidationCacheEXT = unsafe extern "system" fn(device: crate::vk1_0::Device, validation_cache: crate::extensions::ext_validation_cache::ValidationCacheEXT, p_allocator: *const crate::vk1_0::AllocationCallbacks) -> ();
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetValidationCacheDataEXT.html)) · Function <br/> vkGetValidationCacheDataEXT - Get the data store from a validation cache\n[](#_c_specification)C Specification\n----------\n\nData **can** be retrieved from a validation cache object using the command:\n\n```\n// Provided by VK_EXT_validation_cache\nVkResult vkGetValidationCacheDataEXT(\n    VkDevice                                    device,\n    VkValidationCacheEXT                        validationCache,\n    size_t*                                     pDataSize,\n    void*                                       pData);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that owns the validation cache.\n\n* [`Self::validation_cache`] is the validation cache to retrieve data from.\n\n* [`Self::p_data_size`] is a pointer to a value related to the amount of data in\n  the validation cache, as described below.\n\n* [`Self::p_data`] is either `NULL` or a pointer to a buffer.\n[](#_description)Description\n----------\n\nIf [`Self::p_data`] is `NULL`, then the maximum size of the data that **can** be\nretrieved from the validation cache, in bytes, is returned in[`Self::p_data_size`].\nOtherwise, [`Self::p_data_size`] **must** point to a variable set by the user to the\nsize of the buffer, in bytes, pointed to by [`Self::p_data`], and on return the\nvariable is overwritten with the amount of data actually written to[`Self::p_data`].\nIf [`Self::p_data_size`] is less than the maximum size that **can** be retrieved by\nthe validation cache, at most [`Self::p_data_size`] bytes will be written to[`Self::p_data`], and [`crate::vk::DeviceLoader::get_validation_cache_data_ext`] will return[`crate::vk::Result::INCOMPLETE`] instead of [`crate::vk::Result::SUCCESS`], to indicate that not all of\nthe validation cache was returned.\n\nAny data written to [`Self::p_data`] is valid and **can** be provided as the`pInitialData` member of the [`crate::vk::ValidationCacheCreateInfoEXT`]structure passed to [`crate::vk::DeviceLoader::create_validation_cache_ext`].\n\nTwo calls to [`crate::vk::DeviceLoader::get_validation_cache_data_ext`] with the same parameters**must** retrieve the same data unless a command that modifies the contents of\nthe cache is called between them.\n\nApplications **can** store the data retrieved from the validation cache, and\nuse these data, possibly in a future run of the application, to populate new\nvalidation cache objects.\nThe results of validation, however, **may** depend on the vendor ID, device ID,\ndriver version, and other details of the device.\nTo enable applications to detect when previously retrieved data is\nincompatible with the device, the initial bytes written to [`Self::p_data`] **must**be a header consisting of the following members:\n\n|Offset|     Size     |                                                                        Meaning                                                                        |\n|------|--------------|-------------------------------------------------------------------------------------------------------------------------------------------------------|\n|  0   |      4       |               length in bytes of the entire validation cache header written as a stream of bytes, with the least significant byte first               |\n|  4   |      4       |a [`crate::vk::ValidationCacheHeaderVersionEXT`] value written as a stream of bytes, with the least significant byte first|\n|  8   |[`crate::vk::UUID_SIZE`]|    a layer commit ID expressed as a UUID, which uniquely identifies the version of the validation layers used to generate these validation results    |\n\nThe first four bytes encode the length of the entire validation cache\nheader, in bytes.\nThis value includes all fields in the header including the validation cache\nversion field and the size of the length field.\n\nThe next four bytes encode the validation cache version, as described for[`crate::vk::ValidationCacheHeaderVersionEXT`].\nA consumer of the validation cache **should** use the cache version to\ninterpret the remainder of the cache header.\n\nIf [`Self::p_data_size`] is less than what is necessary to store this header,\nnothing will be written to [`Self::p_data`] and zero will be written to[`Self::p_data_size`].\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetValidationCacheDataEXT-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetValidationCacheDataEXT-validationCache-parameter  \n  [`Self::validation_cache`] **must** be a valid [`crate::vk::ValidationCacheEXT`] handle\n\n* []() VUID-vkGetValidationCacheDataEXT-pDataSize-parameter  \n  [`Self::p_data_size`] **must** be a valid pointer to a `size_t` value\n\n* []() VUID-vkGetValidationCacheDataEXT-pData-parameter  \n   If the value referenced by [`Self::p_data_size`] is not `0`, and [`Self::p_data`] is not `NULL`, [`Self::p_data`] **must** be a valid pointer to an array of [`Self::p_data_size`] bytes\n\n* []() VUID-vkGetValidationCacheDataEXT-validationCache-parent  \n  [`Self::validation_cache`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::INCOMPLETE`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ValidationCacheEXT`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetValidationCacheDataEXT = unsafe extern "system" fn(device: crate::vk1_0::Device, validation_cache: crate::extensions::ext_validation_cache::ValidationCacheEXT, p_data_size: *mut usize, p_data: *mut std::ffi::c_void) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkMergeValidationCachesEXT.html)) · Function <br/> vkMergeValidationCachesEXT - Combine the data stores of validation caches\n[](#_c_specification)C Specification\n----------\n\nValidation cache objects **can** be merged using the command:\n\n```\n// Provided by VK_EXT_validation_cache\nVkResult vkMergeValidationCachesEXT(\n    VkDevice                                    device,\n    VkValidationCacheEXT                        dstCache,\n    uint32_t                                    srcCacheCount,\n    const VkValidationCacheEXT*                 pSrcCaches);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that owns the validation cache\n  objects.\n\n* [`Self::dst_cache`] is the handle of the validation cache to merge results\n  into.\n\n* [`Self::src_cache_count`] is the length of the [`Self::p_src_caches`] array.\n\n* [`Self::p_src_caches`] is a pointer to an array of validation cache handles,\n  which will be merged into [`Self::dst_cache`].\n  The previous contents of [`Self::dst_cache`] are included after the merge.\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>The details of the merge operation are implementation-dependent, but<br/>implementations **should** merge the contents of the specified validation<br/>caches and prune duplicate entries.|\n|---|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage\n\n* []() VUID-vkMergeValidationCachesEXT-dstCache-01536  \n  [`Self::dst_cache`] **must** not appear in the list of source caches\n\nValid Usage (Implicit)\n\n* []() VUID-vkMergeValidationCachesEXT-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkMergeValidationCachesEXT-dstCache-parameter  \n  [`Self::dst_cache`] **must** be a valid [`crate::vk::ValidationCacheEXT`] handle\n\n* []() VUID-vkMergeValidationCachesEXT-pSrcCaches-parameter  \n  [`Self::p_src_caches`] **must** be a valid pointer to an array of [`Self::src_cache_count`] valid [`crate::vk::ValidationCacheEXT`] handles\n\n* []() VUID-vkMergeValidationCachesEXT-srcCacheCount-arraylength  \n  [`Self::src_cache_count`] **must** be greater than `0`\n\n* []() VUID-vkMergeValidationCachesEXT-dstCache-parent  \n  [`Self::dst_cache`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\n* []() VUID-vkMergeValidationCachesEXT-pSrcCaches-parent  \n   Each element of [`Self::p_src_caches`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nHost Synchronization\n\n* Host access to [`Self::dst_cache`] **must** be externally synchronized\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ValidationCacheEXT`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkMergeValidationCachesEXT = unsafe extern "system" fn(device: crate::vk1_0::Device, dst_cache: crate::extensions::ext_validation_cache::ValidationCacheEXT, src_cache_count: u32, p_src_caches: *const crate::extensions::ext_validation_cache::ValidationCacheEXT) -> crate::vk1_0::Result;
impl<'a> crate::ExtendableFromConst<'a, ShaderModuleValidationCacheCreateInfoEXT> for crate::vk1_0::ShaderModuleCreateInfoBuilder<'a> {}
impl<'a> crate::ExtendableFromConst<'a, ShaderModuleValidationCacheCreateInfoEXTBuilder<'_>> for crate::vk1_0::ShaderModuleCreateInfoBuilder<'a> {}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkValidationCacheCreateInfoEXT.html)) · Structure <br/> VkValidationCacheCreateInfoEXT - Structure specifying parameters of a newly created validation cache\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ValidationCacheCreateInfoEXT`] structure is defined as:\n\n```\n// Provided by VK_EXT_validation_cache\ntypedef struct VkValidationCacheCreateInfoEXT {\n    VkStructureType                    sType;\n    const void*                        pNext;\n    VkValidationCacheCreateFlagsEXT    flags;\n    size_t                             initialDataSize;\n    const void*                        pInitialData;\n} VkValidationCacheCreateInfoEXT;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::flags`] is reserved for future use.\n\n* [`Self::initial_data_size`] is the number of bytes in [`Self::p_initial_data`].\n  If [`Self::initial_data_size`] is zero, the validation cache will initially be\n  empty.\n\n* [`Self::p_initial_data`] is a pointer to previously retrieved validation cache\n  data.\n  If the validation cache data is incompatible (as defined below) with the\n  device, the validation cache will be initially empty.\n  If [`Self::initial_data_size`] is zero, [`Self::p_initial_data`] is ignored.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkValidationCacheCreateInfoEXT-initialDataSize-01534  \n   If [`Self::initial_data_size`] is not `0`, it **must** be equal to the size of[`Self::p_initial_data`], as returned by [`crate::vk::DeviceLoader::get_validation_cache_data_ext`]when [`Self::p_initial_data`] was originally retrieved\n\n* []() VUID-VkValidationCacheCreateInfoEXT-initialDataSize-01535  \n   If [`Self::initial_data_size`] is not `0`, [`Self::p_initial_data`] **must** have been\n  retrieved from a previous call to [`crate::vk::DeviceLoader::get_validation_cache_data_ext`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkValidationCacheCreateInfoEXT-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::VALIDATION_CACHE_CREATE_INFO_EXT`]\n\n* []() VUID-VkValidationCacheCreateInfoEXT-pNext-pNext  \n  [`Self::p_next`] **must** be `NULL`\n\n* []() VUID-VkValidationCacheCreateInfoEXT-flags-zerobitmask  \n  [`Self::flags`] **must** be `0`\n\n* []() VUID-VkValidationCacheCreateInfoEXT-pInitialData-parameter  \n   If [`Self::initial_data_size`] is not `0`, [`Self::p_initial_data`] **must** be a valid pointer to an array of [`Self::initial_data_size`] bytes\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`], [`crate::vk::ValidationCacheCreateFlagBitsEXT`], [`crate::vk::DeviceLoader::create_validation_cache_ext`]\n"]
#[doc(alias = "VkValidationCacheCreateInfoEXT")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ValidationCacheCreateInfoEXT {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *const std::ffi::c_void,
    pub flags: crate::extensions::ext_validation_cache::ValidationCacheCreateFlagsEXT,
    pub initial_data_size: usize,
    pub p_initial_data: *const std::ffi::c_void,
}
impl ValidationCacheCreateInfoEXT {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::VALIDATION_CACHE_CREATE_INFO_EXT;
}
impl Default for ValidationCacheCreateInfoEXT {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null(), flags: Default::default(), initial_data_size: Default::default(), p_initial_data: std::ptr::null() }
    }
}
impl std::fmt::Debug for ValidationCacheCreateInfoEXT {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("ValidationCacheCreateInfoEXT").field("s_type", &self.s_type).field("p_next", &self.p_next).field("flags", &self.flags).field("initial_data_size", &self.initial_data_size).field("p_initial_data", &self.p_initial_data).finish()
    }
}
impl ValidationCacheCreateInfoEXT {
    #[inline]
    pub fn into_builder<'a>(self) -> ValidationCacheCreateInfoEXTBuilder<'a> {
        ValidationCacheCreateInfoEXTBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkValidationCacheCreateInfoEXT.html)) · Builder of [`ValidationCacheCreateInfoEXT`] <br/> VkValidationCacheCreateInfoEXT - Structure specifying parameters of a newly created validation cache\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ValidationCacheCreateInfoEXT`] structure is defined as:\n\n```\n// Provided by VK_EXT_validation_cache\ntypedef struct VkValidationCacheCreateInfoEXT {\n    VkStructureType                    sType;\n    const void*                        pNext;\n    VkValidationCacheCreateFlagsEXT    flags;\n    size_t                             initialDataSize;\n    const void*                        pInitialData;\n} VkValidationCacheCreateInfoEXT;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::flags`] is reserved for future use.\n\n* [`Self::initial_data_size`] is the number of bytes in [`Self::p_initial_data`].\n  If [`Self::initial_data_size`] is zero, the validation cache will initially be\n  empty.\n\n* [`Self::p_initial_data`] is a pointer to previously retrieved validation cache\n  data.\n  If the validation cache data is incompatible (as defined below) with the\n  device, the validation cache will be initially empty.\n  If [`Self::initial_data_size`] is zero, [`Self::p_initial_data`] is ignored.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-VkValidationCacheCreateInfoEXT-initialDataSize-01534  \n   If [`Self::initial_data_size`] is not `0`, it **must** be equal to the size of[`Self::p_initial_data`], as returned by [`crate::vk::DeviceLoader::get_validation_cache_data_ext`]when [`Self::p_initial_data`] was originally retrieved\n\n* []() VUID-VkValidationCacheCreateInfoEXT-initialDataSize-01535  \n   If [`Self::initial_data_size`] is not `0`, [`Self::p_initial_data`] **must** have been\n  retrieved from a previous call to [`crate::vk::DeviceLoader::get_validation_cache_data_ext`]\n\nValid Usage (Implicit)\n\n* []() VUID-VkValidationCacheCreateInfoEXT-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::VALIDATION_CACHE_CREATE_INFO_EXT`]\n\n* []() VUID-VkValidationCacheCreateInfoEXT-pNext-pNext  \n  [`Self::p_next`] **must** be `NULL`\n\n* []() VUID-VkValidationCacheCreateInfoEXT-flags-zerobitmask  \n  [`Self::flags`] **must** be `0`\n\n* []() VUID-VkValidationCacheCreateInfoEXT-pInitialData-parameter  \n   If [`Self::initial_data_size`] is not `0`, [`Self::p_initial_data`] **must** be a valid pointer to an array of [`Self::initial_data_size`] bytes\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`], [`crate::vk::ValidationCacheCreateFlagBitsEXT`], [`crate::vk::DeviceLoader::create_validation_cache_ext`]\n"]
#[repr(transparent)]
pub struct ValidationCacheCreateInfoEXTBuilder<'a>(ValidationCacheCreateInfoEXT, std::marker::PhantomData<&'a ()>);
impl<'a> ValidationCacheCreateInfoEXTBuilder<'a> {
    #[inline]
    pub fn new() -> ValidationCacheCreateInfoEXTBuilder<'a> {
        ValidationCacheCreateInfoEXTBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn flags(mut self, flags: crate::extensions::ext_validation_cache::ValidationCacheCreateFlagsEXT) -> Self {
        self.0.flags = flags as _;
        self
    }
    #[inline]
    pub fn initial_data_size(mut self, initial_data_size: usize) -> Self {
        self.0.initial_data_size = initial_data_size;
        self
    }
    #[inline]
    pub fn initial_data(mut self, initial_data: *const std::ffi::c_void) -> Self {
        self.0.p_initial_data = initial_data;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> ValidationCacheCreateInfoEXT {
        self.0
    }
}
impl<'a> std::default::Default for ValidationCacheCreateInfoEXTBuilder<'a> {
    fn default() -> ValidationCacheCreateInfoEXTBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for ValidationCacheCreateInfoEXTBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for ValidationCacheCreateInfoEXTBuilder<'a> {
    type Target = ValidationCacheCreateInfoEXT;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for ValidationCacheCreateInfoEXTBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkShaderModuleValidationCacheCreateInfoEXT.html)) · Structure <br/> VkShaderModuleValidationCacheCreateInfoEXT - Specify validation cache to use during shader module creation\n[](#_c_specification)C Specification\n----------\n\nTo use a [`crate::vk::ValidationCacheEXT`] to cache shader validation results, add\na [`crate::vk::ShaderModuleValidationCacheCreateInfoEXT`] structure to the[`Self::p_next`] chain of the [`crate::vk::ShaderModuleCreateInfo`] structure,\nspecifying the cache object to use.\n\nThe [`crate::vk::ShaderModuleValidationCacheCreateInfoEXT`] struct is defined as:\n\n```\n// Provided by VK_EXT_validation_cache\ntypedef struct VkShaderModuleValidationCacheCreateInfoEXT {\n    VkStructureType         sType;\n    const void*             pNext;\n    VkValidationCacheEXT    validationCache;\n} VkShaderModuleValidationCacheCreateInfoEXT;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::validation_cache`] is the validation cache object from which the\n  results of prior validation attempts will be written, and to which new\n  validation results for this [`crate::vk::ShaderModule`] will be written (if not\n  already present).\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkShaderModuleValidationCacheCreateInfoEXT-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::SHADER_MODULE_VALIDATION_CACHE_CREATE_INFO_EXT`]\n\n* []() VUID-VkShaderModuleValidationCacheCreateInfoEXT-validationCache-parameter  \n  [`Self::validation_cache`] **must** be a valid [`crate::vk::ValidationCacheEXT`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`], [`crate::vk::ValidationCacheEXT`]\n"]
#[doc(alias = "VkShaderModuleValidationCacheCreateInfoEXT")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ShaderModuleValidationCacheCreateInfoEXT {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *const std::ffi::c_void,
    pub validation_cache: crate::extensions::ext_validation_cache::ValidationCacheEXT,
}
impl ShaderModuleValidationCacheCreateInfoEXT {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::SHADER_MODULE_VALIDATION_CACHE_CREATE_INFO_EXT;
}
impl Default for ShaderModuleValidationCacheCreateInfoEXT {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null(), validation_cache: Default::default() }
    }
}
impl std::fmt::Debug for ShaderModuleValidationCacheCreateInfoEXT {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("ShaderModuleValidationCacheCreateInfoEXT").field("s_type", &self.s_type).field("p_next", &self.p_next).field("validation_cache", &self.validation_cache).finish()
    }
}
impl ShaderModuleValidationCacheCreateInfoEXT {
    #[inline]
    pub fn into_builder<'a>(self) -> ShaderModuleValidationCacheCreateInfoEXTBuilder<'a> {
        ShaderModuleValidationCacheCreateInfoEXTBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkShaderModuleValidationCacheCreateInfoEXT.html)) · Builder of [`ShaderModuleValidationCacheCreateInfoEXT`] <br/> VkShaderModuleValidationCacheCreateInfoEXT - Specify validation cache to use during shader module creation\n[](#_c_specification)C Specification\n----------\n\nTo use a [`crate::vk::ValidationCacheEXT`] to cache shader validation results, add\na [`crate::vk::ShaderModuleValidationCacheCreateInfoEXT`] structure to the[`Self::p_next`] chain of the [`crate::vk::ShaderModuleCreateInfo`] structure,\nspecifying the cache object to use.\n\nThe [`crate::vk::ShaderModuleValidationCacheCreateInfoEXT`] struct is defined as:\n\n```\n// Provided by VK_EXT_validation_cache\ntypedef struct VkShaderModuleValidationCacheCreateInfoEXT {\n    VkStructureType         sType;\n    const void*             pNext;\n    VkValidationCacheEXT    validationCache;\n} VkShaderModuleValidationCacheCreateInfoEXT;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::validation_cache`] is the validation cache object from which the\n  results of prior validation attempts will be written, and to which new\n  validation results for this [`crate::vk::ShaderModule`] will be written (if not\n  already present).\n[](#_description)Description\n----------\n\nValid Usage (Implicit)\n\n* []() VUID-VkShaderModuleValidationCacheCreateInfoEXT-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::SHADER_MODULE_VALIDATION_CACHE_CREATE_INFO_EXT`]\n\n* []() VUID-VkShaderModuleValidationCacheCreateInfoEXT-validationCache-parameter  \n  [`Self::validation_cache`] **must** be a valid [`crate::vk::ValidationCacheEXT`] handle\n[](#_see_also)See Also\n----------\n\n[`crate::vk::StructureType`], [`crate::vk::ValidationCacheEXT`]\n"]
#[repr(transparent)]
pub struct ShaderModuleValidationCacheCreateInfoEXTBuilder<'a>(ShaderModuleValidationCacheCreateInfoEXT, std::marker::PhantomData<&'a ()>);
impl<'a> ShaderModuleValidationCacheCreateInfoEXTBuilder<'a> {
    #[inline]
    pub fn new() -> ShaderModuleValidationCacheCreateInfoEXTBuilder<'a> {
        ShaderModuleValidationCacheCreateInfoEXTBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn validation_cache(mut self, validation_cache: crate::extensions::ext_validation_cache::ValidationCacheEXT) -> Self {
        self.0.validation_cache = validation_cache as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> ShaderModuleValidationCacheCreateInfoEXT {
        self.0
    }
}
impl<'a> std::default::Default for ShaderModuleValidationCacheCreateInfoEXTBuilder<'a> {
    fn default() -> ShaderModuleValidationCacheCreateInfoEXTBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for ShaderModuleValidationCacheCreateInfoEXTBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for ShaderModuleValidationCacheCreateInfoEXTBuilder<'a> {
    type Target = ShaderModuleValidationCacheCreateInfoEXT;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for ShaderModuleValidationCacheCreateInfoEXTBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "Provided by [`crate::extensions::ext_validation_cache`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkCreateValidationCacheEXT.html)) · Function <br/> vkCreateValidationCacheEXT - Creates a new validation cache\n[](#_c_specification)C Specification\n----------\n\nTo create validation cache objects, call:\n\n```\n// Provided by VK_EXT_validation_cache\nVkResult vkCreateValidationCacheEXT(\n    VkDevice                                    device,\n    const VkValidationCacheCreateInfoEXT*       pCreateInfo,\n    const VkAllocationCallbacks*                pAllocator,\n    VkValidationCacheEXT*                       pValidationCache);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that creates the validation cache\n  object.\n\n* [`Self::p_create_info`] is a pointer to a [`crate::vk::ValidationCacheCreateInfoEXT`]structure containing the initial parameters for the validation cache\n  object.\n\n* [`Self::p_allocator`] controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n\n* [`Self::p_validation_cache`] is a pointer to a [`crate::vk::ValidationCacheEXT`]handle in which the resulting validation cache object is returned.\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>Applications **can** track and manage the total host memory size of a<br/>validation cache object using the [`Self::p_allocator`].<br/>Applications **can** limit the amount of data retrieved from a validation cache<br/>object in [`crate::vk::DeviceLoader::get_validation_cache_data_ext`].<br/>Implementations **should** not internally limit the total number of entries<br/>added to a validation cache object or the total host memory consumed.|\n|---|----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nOnce created, a validation cache **can** be passed to the[`crate::vk::PFN_vkCreateShaderModule`] command by adding this object to the[`crate::vk::ShaderModuleCreateInfo`] structure’s `pNext` chain.\nIf a [`crate::vk::ShaderModuleValidationCacheCreateInfoEXT`] object is included in\nthe [`crate::vk::ShaderModuleCreateInfo::p_next`] chain, and its`validationCache` field is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), the implementation\nwill query it for possible reuse opportunities and update it with new\ncontent.\nThe use of the validation cache object in these commands is internally\nsynchronized, and the same validation cache object **can** be used in multiple\nthreads simultaneously.\n\n|   |Note<br/><br/>Implementations **should** make every effort to limit any critical sections to<br/>the actual accesses to the cache, which is expected to be significantly<br/>shorter than the duration of the [`crate::vk::PFN_vkCreateShaderModule`] command.|\n|---|---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-vkCreateValidationCacheEXT-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkCreateValidationCacheEXT-pCreateInfo-parameter  \n  [`Self::p_create_info`] **must** be a valid pointer to a valid [`crate::vk::ValidationCacheCreateInfoEXT`] structure\n\n* []() VUID-vkCreateValidationCacheEXT-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkCreateValidationCacheEXT-pValidationCache-parameter  \n  [`Self::p_validation_cache`] **must** be a valid pointer to a [`crate::vk::ValidationCacheEXT`] handle\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::Device`], [`crate::vk::ValidationCacheCreateInfoEXT`], [`crate::vk::ValidationCacheEXT`]\n"]
    #[doc(alias = "vkCreateValidationCacheEXT")]
    pub unsafe fn create_validation_cache_ext(&self, create_info: &crate::extensions::ext_validation_cache::ValidationCacheCreateInfoEXT, allocator: Option<&crate::vk1_0::AllocationCallbacks>) -> crate::utils::VulkanResult<crate::extensions::ext_validation_cache::ValidationCacheEXT> {
        let _function = self.create_validation_cache_ext.expect(crate::NOT_LOADED_MESSAGE);
        let mut validation_cache = Default::default();
        let _return = _function(
            self.handle,
            create_info as _,
            match allocator {
                Some(v) => v,
                None => std::ptr::null(),
            },
            &mut validation_cache,
        );
        crate::utils::VulkanResult::new(_return, validation_cache)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkDestroyValidationCacheEXT.html)) · Function <br/> vkDestroyValidationCacheEXT - Destroy a validation cache object\n[](#_c_specification)C Specification\n----------\n\nTo destroy a validation cache, call:\n\n```\n// Provided by VK_EXT_validation_cache\nvoid vkDestroyValidationCacheEXT(\n    VkDevice                                    device,\n    VkValidationCacheEXT                        validationCache,\n    const VkAllocationCallbacks*                pAllocator);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that destroys the validation cache\n  object.\n\n* [`Self::validation_cache`] is the handle of the validation cache to destroy.\n\n* [`Self::p_allocator`] controls host memory allocation as described in the[Memory Allocation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#memory-allocation) chapter.\n[](#_description)Description\n----------\n\nValid Usage\n\n* []() VUID-vkDestroyValidationCacheEXT-validationCache-01537  \n   If [`crate::vk::AllocationCallbacks`] were provided when [`Self::validation_cache`]was created, a compatible set of callbacks **must** be provided here\n\n* []() VUID-vkDestroyValidationCacheEXT-validationCache-01538  \n   If no [`crate::vk::AllocationCallbacks`] were provided when[`Self::validation_cache`] was created, [`Self::p_allocator`] **must** be `NULL`\n\nValid Usage (Implicit)\n\n* []() VUID-vkDestroyValidationCacheEXT-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkDestroyValidationCacheEXT-validationCache-parameter  \n   If [`Self::validation_cache`] is not [VK\\_NULL\\_HANDLE](VK_NULL_HANDLE.html), [`Self::validation_cache`] **must** be a valid [`crate::vk::ValidationCacheEXT`] handle\n\n* []() VUID-vkDestroyValidationCacheEXT-pAllocator-parameter  \n   If [`Self::p_allocator`] is not `NULL`, [`Self::p_allocator`] **must** be a valid pointer to a valid [`crate::vk::AllocationCallbacks`] structure\n\n* []() VUID-vkDestroyValidationCacheEXT-validationCache-parent  \n   If [`Self::validation_cache`] is a valid handle, it **must** have been created, allocated, or retrieved from [`Self::device`]\n\nHost Synchronization\n\n* Host access to [`Self::validation_cache`] **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[`crate::vk::AllocationCallbacks`], [`crate::vk::Device`], [`crate::vk::ValidationCacheEXT`]\n"]
    #[doc(alias = "vkDestroyValidationCacheEXT")]
    pub unsafe fn destroy_validation_cache_ext(&self, validation_cache: Option<crate::extensions::ext_validation_cache::ValidationCacheEXT>, allocator: Option<&crate::vk1_0::AllocationCallbacks>) -> () {
        let _function = self.destroy_validation_cache_ext.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(
            self.handle,
            match validation_cache {
                Some(v) => v,
                None => Default::default(),
            },
            match allocator {
                Some(v) => v,
                None => std::ptr::null(),
            },
        );
        ()
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetValidationCacheDataEXT.html)) · Function <br/> vkGetValidationCacheDataEXT - Get the data store from a validation cache\n[](#_c_specification)C Specification\n----------\n\nData **can** be retrieved from a validation cache object using the command:\n\n```\n// Provided by VK_EXT_validation_cache\nVkResult vkGetValidationCacheDataEXT(\n    VkDevice                                    device,\n    VkValidationCacheEXT                        validationCache,\n    size_t*                                     pDataSize,\n    void*                                       pData);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that owns the validation cache.\n\n* [`Self::validation_cache`] is the validation cache to retrieve data from.\n\n* [`Self::p_data_size`] is a pointer to a value related to the amount of data in\n  the validation cache, as described below.\n\n* [`Self::p_data`] is either `NULL` or a pointer to a buffer.\n[](#_description)Description\n----------\n\nIf [`Self::p_data`] is `NULL`, then the maximum size of the data that **can** be\nretrieved from the validation cache, in bytes, is returned in[`Self::p_data_size`].\nOtherwise, [`Self::p_data_size`] **must** point to a variable set by the user to the\nsize of the buffer, in bytes, pointed to by [`Self::p_data`], and on return the\nvariable is overwritten with the amount of data actually written to[`Self::p_data`].\nIf [`Self::p_data_size`] is less than the maximum size that **can** be retrieved by\nthe validation cache, at most [`Self::p_data_size`] bytes will be written to[`Self::p_data`], and [`crate::vk::DeviceLoader::get_validation_cache_data_ext`] will return[`crate::vk::Result::INCOMPLETE`] instead of [`crate::vk::Result::SUCCESS`], to indicate that not all of\nthe validation cache was returned.\n\nAny data written to [`Self::p_data`] is valid and **can** be provided as the`pInitialData` member of the [`crate::vk::ValidationCacheCreateInfoEXT`]structure passed to [`crate::vk::DeviceLoader::create_validation_cache_ext`].\n\nTwo calls to [`crate::vk::DeviceLoader::get_validation_cache_data_ext`] with the same parameters**must** retrieve the same data unless a command that modifies the contents of\nthe cache is called between them.\n\nApplications **can** store the data retrieved from the validation cache, and\nuse these data, possibly in a future run of the application, to populate new\nvalidation cache objects.\nThe results of validation, however, **may** depend on the vendor ID, device ID,\ndriver version, and other details of the device.\nTo enable applications to detect when previously retrieved data is\nincompatible with the device, the initial bytes written to [`Self::p_data`] **must**be a header consisting of the following members:\n\n|Offset|     Size     |                                                                        Meaning                                                                        |\n|------|--------------|-------------------------------------------------------------------------------------------------------------------------------------------------------|\n|  0   |      4       |               length in bytes of the entire validation cache header written as a stream of bytes, with the least significant byte first               |\n|  4   |      4       |a [`crate::vk::ValidationCacheHeaderVersionEXT`] value written as a stream of bytes, with the least significant byte first|\n|  8   |[`crate::vk::UUID_SIZE`]|    a layer commit ID expressed as a UUID, which uniquely identifies the version of the validation layers used to generate these validation results    |\n\nThe first four bytes encode the length of the entire validation cache\nheader, in bytes.\nThis value includes all fields in the header including the validation cache\nversion field and the size of the length field.\n\nThe next four bytes encode the validation cache version, as described for[`crate::vk::ValidationCacheHeaderVersionEXT`].\nA consumer of the validation cache **should** use the cache version to\ninterpret the remainder of the cache header.\n\nIf [`Self::p_data_size`] is less than what is necessary to store this header,\nnothing will be written to [`Self::p_data`] and zero will be written to[`Self::p_data_size`].\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetValidationCacheDataEXT-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetValidationCacheDataEXT-validationCache-parameter  \n  [`Self::validation_cache`] **must** be a valid [`crate::vk::ValidationCacheEXT`] handle\n\n* []() VUID-vkGetValidationCacheDataEXT-pDataSize-parameter  \n  [`Self::p_data_size`] **must** be a valid pointer to a `size_t` value\n\n* []() VUID-vkGetValidationCacheDataEXT-pData-parameter  \n   If the value referenced by [`Self::p_data_size`] is not `0`, and [`Self::p_data`] is not `NULL`, [`Self::p_data`] **must** be a valid pointer to an array of [`Self::p_data_size`] bytes\n\n* []() VUID-vkGetValidationCacheDataEXT-validationCache-parent  \n  [`Self::validation_cache`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\n* [`crate::vk::Result::INCOMPLETE`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ValidationCacheEXT`]\n"]
    #[doc(alias = "vkGetValidationCacheDataEXT")]
    pub unsafe fn get_validation_cache_data_ext(&self, validation_cache: crate::extensions::ext_validation_cache::ValidationCacheEXT, data_size: *mut usize, data: *mut std::ffi::c_void) -> crate::utils::VulkanResult<()> {
        let _function = self.get_validation_cache_data_ext.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, validation_cache as _, data_size, data);
        crate::utils::VulkanResult::new(_return, ())
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkMergeValidationCachesEXT.html)) · Function <br/> vkMergeValidationCachesEXT - Combine the data stores of validation caches\n[](#_c_specification)C Specification\n----------\n\nValidation cache objects **can** be merged using the command:\n\n```\n// Provided by VK_EXT_validation_cache\nVkResult vkMergeValidationCachesEXT(\n    VkDevice                                    device,\n    VkValidationCacheEXT                        dstCache,\n    uint32_t                                    srcCacheCount,\n    const VkValidationCacheEXT*                 pSrcCaches);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that owns the validation cache\n  objects.\n\n* [`Self::dst_cache`] is the handle of the validation cache to merge results\n  into.\n\n* [`Self::src_cache_count`] is the length of the [`Self::p_src_caches`] array.\n\n* [`Self::p_src_caches`] is a pointer to an array of validation cache handles,\n  which will be merged into [`Self::dst_cache`].\n  The previous contents of [`Self::dst_cache`] are included after the merge.\n[](#_description)Description\n----------\n\n|   |Note<br/><br/>The details of the merge operation are implementation-dependent, but<br/>implementations **should** merge the contents of the specified validation<br/>caches and prune duplicate entries.|\n|---|--------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage\n\n* []() VUID-vkMergeValidationCachesEXT-dstCache-01536  \n  [`Self::dst_cache`] **must** not appear in the list of source caches\n\nValid Usage (Implicit)\n\n* []() VUID-vkMergeValidationCachesEXT-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkMergeValidationCachesEXT-dstCache-parameter  \n  [`Self::dst_cache`] **must** be a valid [`crate::vk::ValidationCacheEXT`] handle\n\n* []() VUID-vkMergeValidationCachesEXT-pSrcCaches-parameter  \n  [`Self::p_src_caches`] **must** be a valid pointer to an array of [`Self::src_cache_count`] valid [`crate::vk::ValidationCacheEXT`] handles\n\n* []() VUID-vkMergeValidationCachesEXT-srcCacheCount-arraylength  \n  [`Self::src_cache_count`] **must** be greater than `0`\n\n* []() VUID-vkMergeValidationCachesEXT-dstCache-parent  \n  [`Self::dst_cache`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\n* []() VUID-vkMergeValidationCachesEXT-pSrcCaches-parent  \n   Each element of [`Self::p_src_caches`] **must** have been created, allocated, or retrieved from [`Self::device`]\n\nHost Synchronization\n\n* Host access to [`Self::dst_cache`] **must** be externally synchronized\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_DEVICE_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ValidationCacheEXT`]\n"]
    #[doc(alias = "vkMergeValidationCachesEXT")]
    pub unsafe fn merge_validation_caches_ext(&self, dst_cache: crate::extensions::ext_validation_cache::ValidationCacheEXT, src_caches: &[crate::extensions::ext_validation_cache::ValidationCacheEXT]) -> crate::utils::VulkanResult<()> {
        let _function = self.merge_validation_caches_ext.expect(crate::NOT_LOADED_MESSAGE);
        let src_cache_count = src_caches.len();
        let _return = _function(self.handle, dst_cache as _, src_cache_count as _, src_caches.as_ptr() as _);
        crate::utils::VulkanResult::new(_return, ())
    }
}
